/*global Drupal: false */
(function ($, undefined) {

var comment_timer_update = function(node, seconds) {
  if (seconds > 0) {
    /* update counter */
    setTimeout(function(){
      seconds -= 1;
      node.countdown.html(seconds);
      comment_timer_update(node, seconds);
    }, 1000);
  }

  else {
    /* Destroy counter; Remove the edit link from the DOM */
    node.el.remove();
  }
};

var timer_update_message = function(node, seconds) {
  if (seconds > 0) {
    /* update counter */
    setTimeout(function(){
      seconds -= 1;
      node.countdown.html(seconds);
      timer_update_message(node, seconds);
    }, 1000);
  }

  else {
    /* destroy counter */
    node.el
      .removeClass('status')
      .html(Drupal.t('This can no longer be edited.'))
      .addClass('error')
    ;
  }
};


Drupal.behaviors.tableSelect = {
  attach: function(context) {
    /* initialize for the comment entries owned by the user */
    $("li.comment-edit a").each(function(){
      var $this = $(this),
      node =
        { 'el': $this,
        'countdown': $this.find('em.placeholder').first()
        },
      seconds = parseInt(node.countdown.text(), 10)
      ;
      comment_timer_update(node, seconds);
    });

    /* initialize countdown for the message area */
    $(".messages").each(function(){
      var $this = $(this),
      node =
        { 'el': $this,
        'countdown': $this.find('em.placeholder').first()
        },
      seconds = parseInt(node.countdown.text(), 10)
      ;
      if (node.countdown.length) {
        timer_update_message(node, seconds);
      }
    });
  }
};

}(jQuery));
